## 64fa803ffcc739ad6a9592d8a24a94ac60f6e8e1

=== Documentation/CMakeLists.txt ===
install(FILES
  ibacm.md
  ibsrpdm.md
  libibcm.md
  libibverbs.md
  librdmacm.md
  rxe.md
  ../README.md
  ../MAINTAINERS
  DESTINATION "${CMAKE_INSTALL_DOCDIR}")

=== ibacm/CMakeLists.txt ===
publish_headers(infiniband
  include/infiniband/acm.h
  include/infiniband/acm_prov.h
  )

# FIXME: Fixup the include scheme to not require all these -Is
include_directories("include")
include_directories("src")
include_directories("linux")

# NOTE: ibacm exports symbols from its own binary for use by ibacm
rdma_sbin_executable(ibacm
  src/acm.c
  src/acm_util.c
  )
target_link_libraries(ibacm LINK_PRIVATE
  ibverbs
  ibumad
  ${CMAKE_THREAD_LIBS_INIT}
  ${CMAKE_DL_LIBS}
  )
# FIXME: We should probably list the symbols we want to export..
set_target_properties(ibacm PROPERTIES ENABLE_EXPORTS TRUE)

# This is a plugin module that dynamically links to ibacm
add_library(ibacmp MODULE
  prov/acmp/src/acmp.c
  )
rdma_set_library_map(ibacmp "prov/acmp/src/libibacmp.map")
target_link_libraries(ibacmp LINK_PRIVATE
  ibacm
  ibverbs
  ibumad
  ${CMAKE_THREAD_LIBS_INIT}
  )
set_target_properties(ibacmp PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY "${BUILD_LIB}")
install(TARGETS ibacmp DESTINATION "${ACM_PROVIDER_DIR}")
# ACM providers are linked into a subdir so that IN_PLACE can work.
file(MAKE_DIRECTORY "${BUILD_LIB}/ibacm/")
rdma_create_symlink("../libibacmp.so" "${BUILD_LIB}/ibacm/libibacmp.so")

rdma_executable(ib_acme
  src/acme.c
  src/libacm.c
  src/parse.c
  )
target_link_libraries(ib_acme LINK_PRIVATE
  ibverbs
  )
target_compile_definitions(ib_acme PRIVATE "-DACME_PRINTS")

rdma_man_pages(
  man/ib_acme.1
  man/ibacm.1
  man/ibacm.7
  man/ibacm_prov.7.in
  )

# FIXME: update the .init.in
set(rdmascript "openibd")
set(prefix "${CMAKE_INSTALL_PREFIX}")
rdma_subst_install(FILES "ibacm.init.in"
  DESTINATION "${CMAKE_INSTALL_INITDDIR}"
  RENAME "ibacm"
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

=== libibumad/CMakeLists.txt ===
publish_headers(infiniband
  umad.h
  umad_cm.h
  umad_sa.h
  umad_sm.h
  umad_str.h
  umad_types.h
  )

rdma_library(ibumad libibumad.map
  # See Documentation/versioning.md
  3 3.0.${PACKAGE_VERSION}
  sysfs.c
  umad.c
  umad_str.c
  )

rdma_subst_install(FILES libibumad.udev-rules
  RENAME libibumad.rules
  DESTINATION "${CMAKE_INSTALL_UDEV_RULESDIR}")

=== rdma-ndd/CMakeLists.txt ===
# COPYRIGHT (c) 2016 Intel Corporation. See COPYING file

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")

rdma_sbin_executable(rdma-ndd
  rdma-ndd.c
  )

target_link_libraries(rdma-ndd LINK_PRIVATE ${UDEV_LIBRARIES})

# FIXME Autogenerate from the .rst
rdma_man_pages(
  rdma-ndd.8.in
  )

install(FILES "rdma-ndd.rules" DESTINATION "${CMAKE_INSTALL_UDEV_RULESDIR}")

rdma_subst_install(FILES "rdma-ndd.service.in"
  DESTINATION "${CMAKE_INSTALL_SYSTEMD_SERVICEDIR}"
  RENAME "rdma-ndd.service")

=== srp_daemon/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${NO_STRICT_ALIASING_FLAGS}")

rdma_man_pages(
  ibsrpdm.1
  srp_daemon.1.in
  srp_daemon.service.5
  srp_daemon_port@.service.5
  )

rdma_sbin_executable(srp_daemon
  srp_daemon.c
  srp_handle_traps.c
  srp_sync.c
  )
target_link_libraries(srp_daemon LINK_PRIVATE
  ibverbs
  ibumad
  ${RT_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
  )

rdma_install_symlink(srp_daemon "${CMAKE_INSTALL_SBINDIR}/ibsrpdm")
# FIXME: Why?
rdma_install_symlink(srp_daemon "${CMAKE_INSTALL_SBINDIR}/run_srp_daemon")
rdma_subst_install(FILES "srp_daemon.sh.in"
  DESTINATION "${CMAKE_INSTALL_SBINDIR}"
  RENAME "srp_daemon.sh"
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

install(FILES start_on_all_ports
  DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/srp_daemon"
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

rdma_subst_install(FILES srp_daemon.service.in
  DESTINATION "${CMAKE_INSTALL_SYSTEMD_SERVICEDIR}"
  RENAME srp_daemon.service
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

rdma_subst_install(FILES srp_daemon_port@.service.in
  DESTINATION "${CMAKE_INSTALL_SYSTEMD_SERVICEDIR}"
  RENAME srp_daemon_port@.service
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)

install(FILES srp_daemon.conf DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}")

install(FILES srp_daemon.rules DESTINATION "${CMAKE_INSTALL_UDEV_RULESDIR}")

# FIXME: The ib init.d file should really be included in rdma-core as well.
set(RDMA_SERVICE "openibd" CACHE STRING "init.d file service name to order srpd after")
# NOTE: These defaults are for CentOS, packagers should override.
set(SRP_DEFAULT_START "2 3 4 5" CACHE STRING "Default-Start service data for srpd")
set(SRP_DEFAULT_STOP "0 1 6" CACHE STRING "Default-Stop service data for srpd")
configure_file(srpd.in "${CMAKE_CURRENT_BINARY_DIR}/srpd")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/srpd"
  DESTINATION "${CMAKE_INSTALL_INITDDIR}"
  PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

=== util/CMakeLists.txt ===
publish_internal_headers(util
  compiler.h
  udma_barrier.h
  util.h
  )

=== libibcm/examples/CMakeLists.txt ===
rdma_test_executable(cmpost cmpost.c)
target_link_libraries(cmpost LINK_PRIVATE ibcm rdmacm)

=== libibumad/tests/CMakeLists.txt ===
rdma_test_executable(umad_reg2 umad_reg2_compat.c)
target_link_libraries(umad_reg2 LINK_PRIVATE ibumad)

rdma_test_executable(umad_register2 umad_register2.c)
target_link_libraries(umad_register2 LINK_PRIVATE ibumad)

rdma_test_executable(umad_compile_test umad_compile_test.c)

=== libibverbs/man/CMakeLists.txt ===
rdma_man_pages(
  ibv_alloc_mw.3
  ibv_alloc_pd.3
  ibv_asyncwatch.1
  ibv_attach_mcast.3
  ibv_bind_mw.3
  ibv_create_ah.3
  ibv_create_ah_from_wc.3
  ibv_create_comp_channel.3
  ibv_create_cq.3
  ibv_create_cq_ex.3
  ibv_create_flow.3
  ibv_create_qp.3
  ibv_create_qp_ex.3
  ibv_create_rwq_ind_table.3
  ibv_create_srq.3
  ibv_create_srq_ex.3
  ibv_create_wq.3
  ibv_devices.1
  ibv_devinfo.1
  ibv_event_type_str.3
  ibv_fork_init.3
  ibv_get_async_event.3
  ibv_get_cq_event.3
  ibv_get_device_guid.3
  ibv_get_device_list.3
  ibv_get_device_name.3
  ibv_get_srq_num.3
  ibv_inc_rkey.3
  ibv_modify_qp.3
  ibv_modify_srq.3
  ibv_modify_wq.3
  ibv_open_device.3
  ibv_open_qp.3
  ibv_open_xrcd.3
  ibv_poll_cq.3
  ibv_post_recv.3
  ibv_post_send.3
  ibv_post_srq_recv.3
  ibv_query_device.3
  ibv_query_device_ex.3
  ibv_query_gid.3
  ibv_query_pkey.3
  ibv_query_port.3
  ibv_query_qp.3
  ibv_query_rt_values_ex.3
  ibv_query_srq.3
  ibv_rate_to_mbps.3
  ibv_rate_to_mult.3
  ibv_rc_pingpong.1
  ibv_reg_mr.3
  ibv_req_notify_cq.3
  ibv_rereg_mr.3
  ibv_resize_cq.3
  ibv_srq_pingpong.1
  ibv_uc_pingpong.1
  ibv_ud_pingpong.1
  ibv_xsrq_pingpong.1
  )
rdma_alias_man_pages(
  ibv_alloc_mw.3 ibv_dealloc_mw.3
  ibv_alloc_pd.3 ibv_dealloc_pd.3
  ibv_attach_mcast.3 ibv_detach_mcast.3
  ibv_create_ah.3 ibv_destroy_ah.3
  ibv_create_ah_from_wc.3 ibv_init_ah_from_wc.3
  ibv_create_comp_channel.3 ibv_destroy_comp_channel.3
  ibv_create_cq.3 ibv_destroy_cq.3
  ibv_create_flow.3 ibv_destroy_flow.3
  ibv_create_qp.3 ibv_destroy_qp.3
  ibv_create_rwq_ind_table.3 ibv_destroy_rwq_ind_table.3
  ibv_create_srq.3 ibv_destroy_srq.3
  ibv_create_wq.3 ibv_destroy_wq.3
  ibv_event_type_str.3 ibv_node_type_str.3
  ibv_event_type_str.3 ibv_port_state_str.3
  ibv_get_async_event.3 ibv_ack_async_event.3
  ibv_get_cq_event.3 ibv_ack_cq_events.3
  ibv_get_device_list.3 ibv_free_device_list.3
  ibv_open_device.3 ibv_close_device.3
  ibv_open_xrcd.3 ibv_close_xrcd.3
  ibv_rate_to_mbps.3 mbps_to_ibv_rate.3
  ibv_rate_to_mult.3 mult_to_ibv_rate.3
  ibv_reg_mr.3 ibv_dereg_mr.3
  )

=== providers/cxgb4/CMakeLists.txt ===
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${NO_STRICT_ALIASING_FLAGS}")

rdma_provider(cxgb4
  cq.c
  dev.c
  qp.c
  verbs.c
)

=== providers/hns/CMakeLists.txt ===
rdma_provider(hns
  hns_roce_u.c
  hns_roce_u_buf.c
  hns_roce_u_hw_v1.c
  hns_roce_u_verbs.c
)

=== providers/mlx4/CMakeLists.txt ===
rdma_provider(mlx4
  buf.c
  cq.c
  dbrec.c
  mlx4.c
  qp.c
  srq.c
  verbs.c
)

=== debian/control ===
Source: rdma-core
Maintainer: Linux RDMA Mailing List <linux-rdma@vger.kernel.org>
Uploaders: Benjamin Drung <benjamin.drung@profitbricks.com>,
           Talat Batheesh <talatb@mellanox.com>
Section: net
Priority: optional
Build-Depends: cmake (>= 2.8.11),
               debhelper (>= 9),
               dh-systemd,
               dpkg-dev (>= 1.17),
               libnl-3-dev,
               libnl-route-3-dev,
               libudev-dev,
               ninja-build,
               pkg-config,
               python,
               valgrind
Standards-Version: 3.9.8
Vcs-Git: https://github.com/linux-rdma/rdma-core.git
Vcs-Browser: https://github.com/linux-rdma/rdma-core
Homepage: https://github.com/linux-rdma/rdma-core

Package: rdma-core
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: RDMA core userspace infrastructure and documentation
 rdma-core provides the basic boot time support (eg systemd integration)
 for systems that use the Linux kernel's RDMA subystem.

Package: ibacm
Architecture: any
Depends: lsb-base (>= 3.2-14~), ${misc:Depends}, ${shlibs:Depends}
Description: InfiniBand Communication Manager Assistant (ACM)
 The IB ACM implements and provides a framework for name, address, and
 route (path) resolution services over InfiniBand.
 It is intended to address connection setup scalability issues running
 MPI applications on large clusters.  The IB ACM provides information
 needed to establish a connection, but does not implement the CM protocol.
 A primary user of the ibacm service is the librdmacm library.

Package: iwpmd
Architecture: linux-any
Depends: infiniband-diags,
         lsb-base (>= 3.2-14~),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Userspace component for iWarp RDMA services
 iwpmd provides a userspace service for iWarp drivers to claim
 tcp ports through the standard socket interface.

Package: ibverbs-providers
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, ${perl:Depends}, ${shlibs:Depends}
Provides: libcxgb3-1, libipathverbs1, libmlx4-1, libmlx5-1, libmthca1, libnes1
Replaces: libcxgb3-1, libipathverbs1, libmlx4-1, libmlx5-1, libmthca1, libnes1
Breaks: libcxgb3-1, libipathverbs1, libmlx4-1, libmlx5-1, libmthca1, libnes1
Description: User space provider drivers for libibverbs
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 A RDMA driver consists of a kernel portion and a user space portion.
 This package contains the user space verbs drivers:
 .
  - bnxt_re: Broadcom NetXtreme-E RoCE HCAs
  - cxgb3: Chelsio T3 iWARP HCAs
  - cxgb4: Chelsio T4 iWARP HCAs
  - hfi1verbs: Intel Omni-Path HFI
  - hns: HiSilicon Hip06 SoC
  - i40iw: Intel Ethernet Connection X722 RDMA
  - ipathverbs: QLogic InfiniPath HCAs
  - mlx4: Mellanox ConnectX-3 InfiniBand HCAs
  - mlx5: Mellanox Connect-IB/X-4+ InfiniBand HCAs
  - mthca: Mellanox InfiniBand HCAs
  - nes: Intel NetEffect NE020-based iWARP adapters
  - ocrdma: Emulex OneConnect RDMA/RoCE device
  - qedr: QLogic QL4xxx RoCE HCAs
  - rxe: A software implementation of the RoCE protocol
  - vmw_pvrdma: VMware paravirtual RDMA device

Package: ibverbs-utils
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Examples for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package contains useful libibverbs1 example programs such as
 ibv_devinfo, which displays information about InfiniBand devices.

Package: libibverbs-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: ibverbs-providers (= ${binary:Version}),
         libibverbs1 (= ${binary:Version}),
         ${misc:Depends}
Description: Development files for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package is needed to compile programs against libibverbs1.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibverbs1
Architecture: linux-any
Multi-Arch: same
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Recommends: ibverbs-providers
Breaks: ibverbs-providers (<< 14)
Description: Library for direct userspace use of RDMA (InfiniBand/iWARP)
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 For this library to be useful, a device-specific plug-in module
 should also be installed.
 .
 This package contains the shared library.

Package: libibverbs1-dbg
Section: debug
Priority: extra
Architecture: linux-any
Multi-Arch: same
Depends: libibverbs1 (= ${binary:Version}), ${misc:Depends}
Description: Debug symbols for the libibverbs library
 libibverbs is a library that allows userspace processes to use RDMA
 "verbs" as described in the InfiniBand Architecture Specification and
 the RDMA Protocol Verbs Specification.  iWARP ethernet NICs support
 RDMA over hardware-offloaded TCP/IP, while InfiniBand is a
 high-throughput, low-latency networking technology.  InfiniBand host
 channel adapters (HCAs) and iWARP NICs commonly support direct
 hardware access from userspace (kernel bypass), and libibverbs
 supports this when available.
 .
 This package contains the debug symbols associated with
 libibverbs1. They will automatically be used by gdb for debugging
 libibverbs-related issues.

Package: libibcm-dev
Section: libdevel
Architecture: linux-any
Depends: libibcm1 (= ${binary:Version}), libibverbs-dev, ${misc:Depends}
Description: Development files for the libibcm library
 libibcm provides a userspace implementation of an InfiniBand
 Communication Manager (CM). The CM handles both connection
 establishment as well as service ID resolution.
 .
 This package is needed to compile programs against libibcm1.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibcm1
Architecture: linux-any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: InfiniBand Communication Manager (CM) library
 libibcm provides a userspace implementation of an InfiniBand
 Communication Manager (CM). The CM handles both connection
 establishment as well as service ID resolution.
 .
 This package contains the shared library.

Package: libibcm1-dbg
Section: debug
Priority: extra
Architecture: linux-any
Depends: libibcm1 (= ${binary:Version}), ${misc:Depends}
Description: Debug symbols for the libibcm1 library
 libibcm provides a userspace implementation of an InfiniBand
 Communication Manager (CM). The CM handles both connection
 establishment as well as service ID resolution.
 .
 This package contains the debug symbols associated with
 libibcm1. They will automatically be used by gdb for debugging
 libibcm-related issues.

Package: libibumad-dev
Section: libdevel
Architecture: linux-any
Depends: libibumad3 (= ${binary:Version}), ${misc:Depends}
Description: Development files for libibumad
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package is needed to compile programs against libibumad.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: libibumad3
Architecture: linux-any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: InfiniBand Userspace Management Datagram (uMAD) library
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package contains the shared library.

Package: libibumad3-dbg
Section: debug
Priority: extra
Architecture: linux-any
Depends: libibumad3 (= ${binary:Version}), ${misc:Depends}
Description: Debug symbols for the libibumad3 library
 libibumad provides userspace Infiniband Management Datagram (uMAD)
 functions which sit on top of the uMAD modules in the kernel.
 These are used by InfiniBand diagnostic and management tools.
 .
 This package contains the debug symbols associated with
 libibumad3. They will automatically be used by gdb for debugging
 libibumad-related issues.

Package: librdmacm-dev
Section: libdevel
Architecture: linux-any
Depends: libibverbs-dev, librdmacm1 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the librdmacm library
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package is needed to compile programs against librdmacm1.
 It contains the header files and static libraries (optionally)
 needed for compiling.

Package: librdmacm1
Architecture: linux-any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library for managing RDMA connections
 librdmacm is a library that allows applications to set up reliable
 connected and unreliable datagram transfers when using RDMA adapters.
 It provides a transport-neutral interface in the sense that the same
 code can be used for both InfiniBand and iWARP adapters.  The
 interface is based on sockets, but adapted for queue pair (QP) based
 semantics: communication must use a specific RDMA device, and data
 transfers are message-based.
 .
 librdmacm only provides communication management (connection setup
 and tear-down) and works in conjunction with the verbs interface
 provided by libibverbs, which provides the interface used to actually
 transfer data.
 .
 This package contains the shared library.

Package: librdmacm1-dbg
Section: debug
Priority: extra
Architecture: linux-any
